<template>
  <div class='app_button'>
    <button class="btn btn-outline-info" @click="toggleModal">Update status</button>

    <modal :modal-id="modalId">
      <h4 style='margin-bottom: 60px; margin-top: 60px;'>
        Update status:  
      </h4>
      <p>
        Current: {{order.status}} 
      </p>
      <button class='btn btn-outline-secondary' @click="toggleModal('changeStatusModal')"> Back </button>
      <button class="btn btn-outline-info" v-bind:class="{active: order.status=='started'}" @click="changeStatus('started')"> Started </button>
      <button class="btn btn-outline-info" v-bind:class="{active: order.status=='finalized'}" @click="changeStatus('finalized')"> Finalized </button>
      <button class="btn btn-outline-info" v-bind:class="{active: order.status=='ordered'}" @click="changeStatus('ordered')"> Ordered </button>
      <button class="btn btn-outline-info" v-bind:class="{active: order.status=='delivered'}" @click="changeStatus('delivered')"> Delivered </button>
    </modal>
  </div>
</template>

<script>
export default {
    data () {
      return {
        message: '',
        modalId: `changeOrderStatusButton-${this.order.id}`
      }
    },
    props: ['order'],
    methods: {
      toggleModal() {
        this.$root.$emit(`toggleModal-${this.modalId}`)
      },
      changeStatus(newStatus) {
        this.$http.patch(`api/v1/orders_change_status/${this.order.id}`, {status: newStatus} ).then((response) => {
          this.order.status = response.data.status
          this.$store.dispatch('updateOrder', response.data.order )
        }).catch((error) => {
          this.$root.$emit(`displayError`, (error.response.data.message))
        })
        this.toggleModal()
      }
    }
  }
</script>
